QGIS Application - Bug report #11693
provider.addFeatures() returns True but fails
2014-11-19 01:27 PM - James Novak

Status: Closed

Priority: Normal

Assignee:

Category: Data Provider

Affected QGIS version:2.6.0 Regression?: No
Operating System: Windows Easy fix?: No

Pull Request or Patch supplied: Resolution: end of life
Crashes QGIS or corrupls data: Copied to github as #: 19937
Description

With a PostGIS vector layer, providing a bad primary key produces the correct provider.hasErrors() and provider.errors() messages, but
the method call returns True despite failing.

Found when developing a Python plugin.
The code involved (table has id primary key, and note varchar()):

feat = QgsFeature()

myfields = layer.dataProvider().fields()

feat.setFields(myfields)

feat.setAttribute("id", None) # The line that causes the failure. None gets translated to 0, which id already exists in table
feat.setAttribute("note", "test")

feat.setGeometry(QgsGeometry.fromPoint(point))

res = layer.dataProvider().addFeatures([feat])

# addFeature fails, but res == True !! BUG

History

#1 - 2014-11-19 03:13 PM - Juirgen Fischer

Any output in the log?

#2 - 2014-11-19 03:52 PM - Jiirgen Fischer

- Status changed from Open to Feedback

#3 - 2014-11-20 08:25 AM - James Novak

Nothing in the QGIS Log window.

#4 - 2015-12-20 09:45 AM - Giovanni Manghi

- Status changed from Feedback to Open

#5 - 2017-05-01 01:07 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#6 - 2019-03-09 03:12 PM - Giovanni Manghi
- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-Itr/
